In greater detail
-----------------

Until now, most students coming to this course have likely taken COMP
170, 271, and (possibly) 313. These courses all help to establish a
solid foundation for how to craft basic computer programs. Both COMP 313
and 330 are about making the transition toward the development and
maintenance of real-world software. The hope is that the student is set
up for the transition to “professional life” and more independent work,
which may come in the form of an industry job, a start up, or perhaps
continued academic/research life.

In this course, we are going to focus on the design and engineering
processes with a bit less emphasis (but not zero) on programming. Design
and engineering are both crucial in a distributed world, where there are
often many moving parts running on a multitude of systems (mobile
devices, web browsers, desktops, clouds, and other networked things,
a.k.a. IoT). Writing reliable software is therefore more important than
ever. The primary focus of this course is to cover design methods within
the context of the software engineering process. A term project is
assigned, but the deliverable is a complete software requirements and
design specification that is considerably more detailed than what you
are likely to have experienced in earlier courses (or internships).
We’ll place emphasis on the implementation of a high quality[^1]
software prototype, which will be evaluated according to multiple
criteria besides whether it works.

Prerequisites
-------------

COMP 271 background is an absolute must. Even if you “know the
material”, the purpose of this prerequisite is to know that you have
spent significant time behind a computer and have learned to write
functioning programs.

COMP 313 is highly recommended and would prove helpful, especially for
the powerful object-oriented background it provides. Fluency with
classes and objects is going to be assumed, regardless of whether you
have this course, since you should know it from COMP 271. If you don’t
know OOP, you need to see me right away.

All students are expected to be familiar with core data structures and
collection classes in at least one language. I generally do most of my
work in Python, Java, and Scala (and formerly in C/C++). There is a
substantial development project, and all are expected to contribute. We
will assess language fluency/interests in the first couple of weeks of
class.

Recommended Textbook
----------------------

Pressman and Maxim, Software Engineering: A Practitioner’s Approach, 8th
Edition

Book Publisher Site:
[*http://highered.mheducation.com/sites/0078022126/information\_center\_view0/index.html*](http://highered.mheducation.com/sites/0078022126/information_center_view0/index.html)

Please note that earlier editions of this book are available. We use this book only as a reference text, so any version you can find in print or online will do. We will discuss this topic during the first class.

Communication
-------------

All communication for this course takes place through Slack, which also
allows for private, direct messages with the instructor. Please do not
use e-mail unless there is some issue with Slack’s availability (which
is unlikely). This will greatly enhance your experience as a student.

The Slack URL is
[*http://luc-se.slack.com/signup*](http://luc-se.slack.com/signup).

We will also use the university Sakai setup for forum-based
communication, especially when it needs to be graded. :-)

Collaboration
-------------

We will make extensive use of cloud computing technology throughout the
semester. You might as well get started by ensuring you have IDs on
these core services:

-   Google

-   GitHub

-   Slack

We will make use of these for project work:

-   Trello - allows signup with Google. Teams are required to use Trello for project management.

-   Cloud 9 - great for having a team sandbox and sharing with me. I will ask that anyone wanting me to look at code use Cloud 9.

-   Bitbucket - private repositories (beyond what GitHub allows)

Others may be added to this list.

Topics
------

\label{topics}

This is a tentative schedule. I’m loathe to say that this is by week,
because some topics will take more time than others. We also need time
for project-related manners. A schedule of due dates/deliverables will
be posted on Sakai.
